#include <stdio.h>
#include <stdlib.h>
#include <fstream>
#include <windows.h>
#include "exporthresource.h"

HINSTANCE hDllModule;
int charSeg;


BOOL APIENTRY DllMain( HINSTANCE hModule, DWORD ul_reason_for_call, LPVOID lpReserved )
{
   hDllModule = hModule;
   
   switch (ul_reason_for_call)
   {
      case DLL_PROCESS_ATTACH:
      case DLL_THREAD_ATTACH:
      case DLL_THREAD_DETACH:
      case DLL_PROCESS_DETACH:
      break;
   }
   return TRUE;
}

int GetPluginName(BYTE * name, WORD * version)
{
    char myname[20] = "Export to *.h"; //No more that 20 chars
    memcpy(name,myname,14);
    //WORD myversion = 0x0100; //Version(8) | Subversion(8)
    *version = 0x0100;//myversion;
    return 1;
}

///////////////////////////////////////////////////////////////////
// Plugin Start Function
// pSet: Pointer to a 256x128 image - Type: BYTE Image[128][256] - NULL: no Charset active
// pMap: Pointer to a 4096 bgmap    - Type; WORD BGMap[4096]     - NULL: no Charmap active
// hValidWnd: Handle of the owner window to perform window updates.
///////////////////////////////////////////////////////////////////
// The Charset image only support 4 values, 0x00, 0x55, 0xAA, 0xFF
///////////////////////////////////////////////////////////////////
// BGMAP WORD Map structure
// | 15 | 14 | 13    | 12    | 11 | 10 | 09 | 08 | 07 | 06 | 05 | 04 | 03 | 02 | 01 | 00 |
// | GPLTX   | HFlip | VFlip | CHARACTER NUMBER IN SET - From 0, to 0x1FF                |


BOOL CALLBACK CharSegDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
    switch(Message)
    {
        case WM_INITDIALOG:
			charSeg = 0x000;
			CheckRadioButton(hwnd, 1001, 1004, 1001);
        return TRUE;
        case WM_COMMAND:
            switch(LOWORD(wParam))
            {
				case 1001:
					charSeg = 0x000;
				break;
				case 1002:
					charSeg = 0x200;
				break;
				case 1003:
					charSeg = 0x400;
				break;
				case 1004:
					charSeg = 0x600;
				break;
				case IDOK:
                    EndDialog(hwnd, IDOK);
                break;
                case IDCANCEL:
                    EndDialog(hwnd, IDCANCEL);
                break;
            }
        break;
        default:
            return FALSE;
    }
    return TRUE;
}

int PluginStart(BYTE * pSet, WORD * pMap, HWND hValidWnd)
{
   int i, dummy, dumm2;
   char title[80];
   OPENFILENAME ofn;
   char szFile[256] = "";
   szFile[0] = '\0';
   ZeroMemory(&ofn, sizeof(ofn));


   ofn.lStructSize = sizeof(OPENFILENAME); 
   ofn.hwndOwner = NULL; 
   ofn.lpstrFilter = "H Files (*.h)\0*.h\0All Files (*.*)\0*.*\0"; 
   ofn.lpstrFile= szFile; 
   ofn.nMaxFile = 256;
   ofn.lpstrDefExt = "h";
   //ofn.lpstrFileTitle = NULL; 
   //ofn.nMaxFileTitle = sizeof(szFileTitle); 
   //ofn.lpstrInitialDir = (LPSTR)NULL; 
   ofn.Flags = OFN_EXPLORER | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT; 
   //ofn.lpstrTitle = NULL; 

   
   if( !hValidWnd ) return 0;
   if( !pSet && !pMap )
      MessageBox(NULL,"Plugin only works with Charset or Charmaps","Export to *.h",MB_OK|MB_ICONASTERISK);
   //if( pSet && MessageBox(NULL,"Do you want to clean this Charset?","Cleaner",MB_YESNO|MB_ICONQUESTION) == IDYES )
   if( pSet && GetSaveFileName(&ofn))
   {
	  std::ofstream file(ofn.lpstrFile);
	  file.fill('0');
	  GetWindowText(hValidWnd, title, sizeof(title));
      for (i=0; title[i] != '\0'; i++)
         title[i] = toupper(title[i]);

	  file << "#ifndef _" << title << "_\n";
	  file << "#define _" << title << "_\n";
	  file << "const BYTE " << title << "[] = {\n";	  
	  for(i=16; i > 0; i--) {
		  for (int j=0; j < 32; j++) {
		     file << "\t";
		     file.setf(std::ios::hex, std::ios::basefield);
			 for( int k=1; k < 9; k++) {
			    dummy = 0;
			    dumm2 = 0;
			    //for(int k=0; k < 4; k++)
			    //   dummy |= ((*(pSet+(i*64)+(j*4)+k)) & (0x03 << (k << 2)));
			    dummy |= ((int)*(pSet+(i*2048)+(j*8)-(k*256)+0) & 0x03);
			    dummy |= ((int)*(pSet+(i*2048)+(j*8)-(k*256)+1) & 0x0c);
			    dummy |= ((int)*(pSet+(i*2048)+(j*8)-(k*256)+2) & 0x30);
			    dummy |= ((int)*(pSet+(i*2048)+(j*8)-(k*256)+3) & 0xc0);
			
			    dumm2 |= ((int)*(pSet+(i*2048)+(j*8)-(k*256)+4) & 0x03);
			    dumm2 |= ((int)*(pSet+(i*2048)+(j*8)-(k*256)+5) & 0x0c);
			    dumm2 |= ((int)*(pSet+(i*2048)+(j*8)-(k*256)+6) & 0x30);
			    dumm2 |= ((int)*(pSet+(i*2048)+(j*8)-(k*256)+7) & 0xc0);
			
			    file << "0x";
			    file.width(2);
			    file << (dummy&0xff) << ",";
			    file << "0x";
			    file.width(2);
			    file << (dumm2&0xff);
			    if (i != 1 || j != 31 || k != 8) file << ","; else file << " ";
			    if (k == 4) file << "\n\t";
		     }
		     file.setf(std::ios::dec, std::ios::basefield);
		     file << "\t/*Char" << ((16-i)*32+j) << "*/\n";
		  }
	  }
      file << "};\n#endif";
         //*(pSet+i) = 0x00;
		 //InvalidateRect(hValidWnd,NULL,FALSE);
   }
   //else if( pMap && MessageBox(NULL,"Export so that it uses CharSeg(3)?","Include",MB_YESNO|MB_ICONQUESTION) == IDYES )
   else if( pMap && DialogBox(hDllModule, MAKEINTRESOURCE(101), NULL, CharSegDlgProc) == IDOK )
   {
	  if (GetSaveFileName(&ofn))
	  {
      std::ofstream file(ofn.lpstrFile);
	  file.fill('0');
	  GetWindowText(hValidWnd, title, sizeof(title));
      for (i=0; title[i] != '\0'; i++)
         title[i] = toupper(title[i]);

	  file << "#ifndef _" << title << "_\n";
	  file << "#define _" << title << "_\n";
	  file << "const BYTE " << title << "[] = {\n";
	  for( i=0; i < 1024; i++ ) {
         //*(pMap+i) = 0x0000;
		 file << "\t";
		 file.setf(std::ios::hex, std::ios::basefield);
		 for( int j=0; j < 4; j++) {
			file << "0x";
			file.width(2);
			file << ((*(pMap+(i*4)+j)+charSeg)&0xFF) << ",";
			file << "0x";
			file.width(2);
			file << (((*(pMap+(i*4)+j)+charSeg)>>8)&0xFF);
		    if (i != 1023 || j != 3) file << ","; else file << " ";
		 }
		 file.setf(std::ios::dec, std::ios::basefield);
		 file << "\t/*Ref" << i << "*/\n";
		 //InvalidateRect(hValidWnd,NULL,FALSE);
	  }
	  file << "};\n#endif";
	  }
   }
   return 1;
}
