#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include "swapresource.h"

HINSTANCE hDllModule;
int color[4];


BOOL APIENTRY DllMain( HINSTANCE hModule, DWORD ul_reason_for_call, LPVOID lpReserved )
{
   hDllModule = hModule;
   
   switch (ul_reason_for_call)
   {
      case DLL_PROCESS_ATTACH:
      case DLL_THREAD_ATTACH:
      case DLL_THREAD_DETACH:
      case DLL_PROCESS_DETACH:
      break;
   }
   return TRUE;
}

int GetPluginName(BYTE * name, WORD * version)
{
    char myname[20] = "Swap colors"; //No more that 20 chars
    memcpy(name,myname,12);
    //WORD myversion = 0x0100; //Version(8) | Subversion(8)
    *version = 0x0100;//myversion;
    return 1;
}

BOOL CALLBACK CharSegDlgProc(HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
{
    switch(Message)
    {
        case WM_INITDIALOG:
			color[0] = 0x00;
			color[1] = 0x55;
			color[2] = 0xAA;
			color[3] = 0xFF;
			CheckRadioButton(hwnd, 1001, 1004, 1001);
			CheckRadioButton(hwnd, 1005, 1008, 1006);
			CheckRadioButton(hwnd, 1009, 1012, 1011);
			CheckRadioButton(hwnd, 1013, 1016, 1016);
        return TRUE;
        case WM_COMMAND:
            switch(LOWORD(wParam))
            {
				case 1001:
					color[0] = 0x00;
				break;
				case 1002:
					color[0] = 0x55;
				break;
				case 1003:
					color[0] = 0xAA;
				break;
				case 1004:
					color[0] = 0xFF;
				break;
				case 1005:
					color[1] = 0x00;
				break;
				case 1006:
					color[1] = 0x55;
				break;
				case 1007:
					color[1] = 0xAA;
				break;
				case 1008:
					color[1] = 0xFF;
				break;
				case 1009:
					color[2] = 0x00;
				break;
				case 1010:
					color[2] = 0x55;
				break;
				case 1011:
					color[2] = 0xAA;
				break;
				case 1012:
					color[2] = 0xFF;
				break;
				case 1013:
					color[3] = 0x00;
				break;
				case 1014:
					color[3] = 0x55;
				break;
				case 1015:
					color[3] = 0xAA;
				break;
				case 1016:
					color[3] = 0xFF;
				break;
				case IDOK:
                    EndDialog(hwnd, IDOK);
                break;
                case IDCANCEL:
                    EndDialog(hwnd, IDCANCEL);
                break;
            }
        break;
        default:
            return FALSE;
    }
    return TRUE;
}

///////////////////////////////////////////////////////////////////
// Plugin Start Function
// pSet: Pointer to a 256x128 image - Type: BYTE Image[128][256] - NULL: no Charset active
// pMap: Pointer to a 4096 bgmap    - Type; WORD BGMap[4096]     - NULL: no Charmap active
// hValidWnd: Handle of the owner window to perform window updates.
///////////////////////////////////////////////////////////////////
// The Charset image only support 4 values, 0x00, 0x55, 0xAA, 0xFF
///////////////////////////////////////////////////////////////////
// BGMAP WORD Map structure
// | 15 | 14 | 13    | 12    | 11 | 10 | 09 | 08 | 07 | 06 | 05 | 04 | 03 | 02 | 01 | 00 |
// | GPLTX   | HFlip | VFlip | CHARACTER NUMBER IN SET - From 0, to 0x1FF                |

int PluginStart(BYTE * pSet, WORD * pMap, HWND hValidWnd)
{
   int i;

   if( !hValidWnd ) return 0;
   if( !pSet )
      MessageBox(NULL,"Plugin only works with Charsets","Swap colors",MB_OK|MB_ICONASTERISK);
   //if( pSet && MessageBox(NULL,"Do you want to clean this Charset?","Cleaner",MB_YESNO|MB_ICONQUESTION) == IDYES )
   if( pSet && DialogBox(hDllModule, MAKEINTRESOURCE(101), NULL, CharSegDlgProc) == IDOK)
   {
	  for( i=0; i < 256*128; i++ ) {
	      if (*(pSet+i) == 0x00) *(pSet+i) = 0x01;
		  if (*(pSet+i) == 0x55) *(pSet+i) = 0x56;
		  if (*(pSet+i) == 0xAA) *(pSet+i) = 0xAB;
		  if (*(pSet+i) == 0xFF) *(pSet+i) = 0xFE;
	  }

	  for( i=0; i < 256*128; i++ ) {
	      if (*(pSet+i) == 0x01) *(pSet+i) = color[0];
		  if (*(pSet+i) == 0x56) *(pSet+i) = color[1];
		  if (*(pSet+i) == 0xAB) *(pSet+i) = color[2];
		  if (*(pSet+i) == 0xFE) *(pSet+i) = color[3];
	  }
      
	  InvalidateRect(hValidWnd,NULL,FALSE);	  
   }
   return 1;
}
